package com.laihua.projecthelper.submerge

import java.io.File
import java.lang.StringBuilder

/**
 *合并助手,用于动画模块开子模块分支的时候,跟开发模块合并的工具类
 * 目前合并完成应该不再使用了
 */

main()
fun main() {
    println("开始运行")
    //要检查合并的目录
    val targetPath = "C:\\Android\\workspace\\laihua-hw"

    val targetFile = File(targetPath)
    //旧模块名字,未移动之前
    val mKtModelOldDirs = targetFile.listFiles()?.filter {
        it.isDirectory && it.name.startsWith("m_kt", true)
    }

    //新模块的父目录位置
    val mKtModelNewParentDirs = targetFile.listFiles()?.filter {
        it.isDirectory && it.name.startsWith("mod_", true)
    }

    //所有的不在子模块里面的文件
    val outModuleFiles = mutableListOf<File>()
    mKtModelOldDirs?.forEach {
        println("旧模块文件夹列表:${it.name}")
        val allFilesIncludeSub = it.getAllFilesIncludeSub()
        outModuleFiles.addAll(allFilesIncludeSub)
        for (file in allFilesIncludeSub) {
            println("--> ${file.path}")
        }
        it.walk().forEach { oneDir ->
            if (oneDir.isDirectory && oneDir.listFiles()?.size == 0) {
                println("空文件夹:${oneDir.path}")
                oneDir.deleteEmptyDir()
            }
        }
    }
    val sumOf = mKtModelOldDirs?.sumOf {
        it.getAllFilesIncludeSub().size
    }
    println("文件总数:$sumOf")
    println("----------------------------------------")

    val moveInfoList = mutableListOf<MoveInfo>()
    outModuleFiles.forEach { oldFile ->
        if (oldFile.path.endsWith("gradle")) {
            return@forEach
        }
        var tmpPath = oldFile.path.replace(targetPath, "")
        if (tmpPath.startsWith(File.separator)) {
            tmpPath = tmpPath.replaceFirst(File.separator, "")
        }
        //所属模块名字
        val moduleName = tmpPath.substring(0, tmpPath.indexOf(File.separator))
//        println("新位置1 $tmpPath  $moduleName")

        mKtModelNewParentDirs?.forEach { newParentFile: File ->
            newParentFile.listFiles()?.find {
                it.name == moduleName
            }?.let { newParentFileTarget ->

                var replace = oldFile.path.replace(targetPath, "")
                replace = replace.replaceFirst("${File.separator}$moduleName", "")
                replace = newParentFileTarget.path + replace

                if (File(replace).exists()) {
                    println("新位置,存在相同文件 ${oldFile.path} -> $replace")
                    moveInfoList.add(MoveInfo(moduleName, oldFile, File(replace)))
                } else {

//                    println("新位置,需要新增的文件 ${oldFile.path} -> $replace")
                }
            }

        }
    }

    println("需要移动的总数:${moveInfoList.size}")

    val logFile = File("E:\\海外合并备份\\移动记录.txt")
    val sb = StringBuilder()
    moveInfoList.forEach {
        val s = "${it.moduleName} ${it.new.name}\n${it.old.path}\n${it.new.path}"
        sb.append(s).append("\n\n")
//        it.oldCoverNew()
    }
    sb.append("总数:${moveInfoList.size}")
    logFile.delete()
    logFile.createNewFile()
    logFile.writeText(sb.toString())


}

class MoveInfo(val moduleName: String, val old: File, val new: File) {
    /**
     * 旧文件覆盖新文件
     */
    fun oldCoverNew() {
        new.delete()
        old.renameTo(new)
    }
}

/**
 * 获取所有文件,包括子文件的子文件,(包含最深度的文件)
 */
fun File.getAllFilesIncludeSub(): List<File> {
    if (this.isFile) {
        throw IllegalArgumentException()
    }
    val directory = this
    val files = mutableListOf<File>()
    if (directory.exists() && directory.isDirectory) {
        directory.listFiles()?.forEach { file ->
            if (file.isFile) {
                files.add(file)
            } else {
                files.addAll(file.getAllFilesIncludeSub())
            }
        }
    }
    return files
}

fun File.deleteEmptyDir() {
    if (this.isDirectory) {
        if (this.listFiles()?.size == 0) {
            this.delete()
            this.parentFile.deleteEmptyDir()
        }
    }
}
